diff --git a/Client/Client/Assets/Scenes/WebGL.unity b/Client/Client/Assets/Scenes/WebGL.unity
index e063e5e..03fdb31 100644
--- a/Client/Client/Assets/Scenes/WebGL.unity
+++ b/Client/Client/Assets/Scenes/WebGL.unity
@@ -26104,12 +27184,12 @@ RectTransform:
   m_LocalScale: {x: 1, y: 1, z: 1}
   m_Children: []
   m_Father: {fileID: 1641538590}
-  m_RootOrder: 17
+  m_RootOrder: 23
   m_LocalEulerAnglesHint: {x: 0, y: 0, z: 0}
-  m_AnchorMin: {x: 0, y: 1}
-  m_AnchorMax: {x: 0, y: 1}
-  m_AnchoredPosition: {x: 877.5, y: -1937.31}
-  m_SizeDelta: {x: 367, y: 287}
+  m_AnchorMin: {x: 0, y: 0}
+  m_AnchorMax: {x: 0, y: 0}
+  m_AnchoredPosition: {x: 0, y: 0}
+  m_SizeDelta: {x: 367, y: 0}
   m_Pivot: {x: 0.5, y: 0.5}
 --- !u!114 &1702604381
 MonoBehaviour:
@@ -27926,10 +29006,10 @@ RectTransform:
   m_Father: {fileID: 1641538590}
   m_RootOrder: 11
   m_LocalEulerAnglesHint: {x: 0, y: 0, z: 0}
-  m_AnchorMin: {x: 0, y: 1}
-  m_AnchorMax: {x: 0, y: 1}
-  m_AnchoredPosition: {x: 877.5, y: -1127.595}
-  m_SizeDelta: {x: 1725, y: 28.13}
+  m_AnchorMin: {x: 0, y: 0}
+  m_AnchorMax: {x: 0, y: 0}
+  m_AnchoredPosition: {x: 0, y: 0}
+  m_SizeDelta: {x: 1725, y: 0}
   m_Pivot: {x: 0.5, y: 0.5}
 --- !u!114 &1816361343
 MonoBehaviour:
@@ -28139,9 +29219,9 @@ RectTransform:
   m_RootOrder: 0
   m_LocalEulerAnglesHint: {x: 0, y: 0, z: 0}
   m_AnchorMin: {x: 0, y: 0}
-  m_AnchorMax: {x: 1, y: 1}
+  m_AnchorMax: {x: 0, y: 0}
   m_AnchoredPosition: {x: 0, y: 0}
-  m_SizeDelta: {x: -17, y: 0}
+  m_SizeDelta: {x: 0, y: 0}
   m_Pivot: {x: 0, y: 1}
 --- !u!114 &1822448961
 MonoBehaviour:
@@ -28314,6 +29394,8 @@ MonoBehaviour:
   labelCanvas: {fileID: 28716932}
   labelPrefab: {fileID: 2200878503183782622, guid: 346106f8583ff85499c5966500ad6102,
     type: 3}
+  smallLabelPrefab: {fileID: 5307734731816753802, guid: a9f6e52d39f0f284cae437de9f25d81b,
+    type: 3}
   underlayTemplate: {fileID: 6353782347770371216, guid: 74b5227b733784b449327a9a52b751a6,
     type: 3}
   overlayTemplate: {fileID: 6177358606749812705, guid: cbae417372ce719448123b88f12d4eec,
@@ -29162,7 +30244,141 @@ CanvasRenderer:
   m_CorrespondingSourceObject: {fileID: 0}
   m_PrefabInstance: {fileID: 0}
   m_PrefabAsset: {fileID: 0}
-  m_GameObject: {fileID: 1882650573}
+  m_GameObject: {fileID: 1882650573}
+  m_CullTransparentMesh: 0
+--- !u!1 &1899073946
+GameObject:
+  m_ObjectHideFlags: 0
+  m_CorrespondingSourceObject: {fileID: 0}
+  m_PrefabInstance: {fileID: 0}
+  m_PrefabAsset: {fileID: 0}
+  serializedVersion: 6
+  m_Component:
+  - component: {fileID: 1899073947}
+  - component: {fileID: 1899073949}
+  - component: {fileID: 1899073948}
+  m_Layer: 5
+  m_Name: Gap (3)
+  m_TagString: Untagged
+  m_Icon: {fileID: 0}
+  m_NavMeshLayer: 0
+  m_StaticEditorFlags: 0
+  m_IsActive: 1
+--- !u!224 &1899073947
+RectTransform:
+  m_ObjectHideFlags: 0
+  m_CorrespondingSourceObject: {fileID: 0}
+  m_PrefabInstance: {fileID: 0}
+  m_PrefabAsset: {fileID: 0}
+  m_GameObject: {fileID: 1899073946}
+  m_LocalRotation: {x: 0, y: 0, z: 0, w: 1}
+  m_LocalPosition: {x: 0, y: 0, z: 0}
+  m_LocalScale: {x: 1, y: 1, z: 1}
+  m_Children: []
+  m_Father: {fileID: 1641538590}
+  m_RootOrder: 16
+  m_LocalEulerAnglesHint: {x: 0, y: 0, z: 0}
+  m_AnchorMin: {x: 0, y: 0}
+  m_AnchorMax: {x: 0, y: 0}
+  m_AnchoredPosition: {x: 0, y: 0}
+  m_SizeDelta: {x: 1725, y: 0}
+  m_Pivot: {x: 0.5, y: 0.5}
+--- !u!114 &1899073948
+MonoBehaviour:
+  m_ObjectHideFlags: 0
+  m_CorrespondingSourceObject: {fileID: 0}
+  m_PrefabInstance: {fileID: 0}
+  m_PrefabAsset: {fileID: 0}
+  m_GameObject: {fileID: 1899073946}
+  m_Enabled: 1
+  m_EditorHideFlags: 0
+  m_Script: {fileID: 11500000, guid: f4688fdb7df04437aeb418b961361dc5, type: 3}
+  m_Name: 
+  m_EditorClassIdentifier: 
+  m_Material: {fileID: 0}
+  m_Color: {r: 1, g: 1, b: 1, a: 1}
+  m_RaycastTarget: 1
+  m_Maskable: 1
+  m_OnCullStateChanged:
+    m_PersistentCalls:
+      m_Calls: []
+  m_text: ' '
+  m_isRightToLeft: 0
+  m_fontAsset: {fileID: 11400000, guid: 49750830b71ed3546bebefe4be946048, type: 2}
+  m_sharedMaterial: {fileID: 1742611629344109958, guid: 49750830b71ed3546bebefe4be946048,
+    type: 2}
+  m_fontSharedMaterials: []
+  m_fontMaterial: {fileID: 0}
+  m_fontMaterials: []
+  m_fontColor32:
+    serializedVersion: 2
+    rgba: 4278190080
+  m_fontColor: {r: 0, g: 0, b: 0, a: 1}
+  m_enableVertexGradient: 0
+  m_colorMode: 3
+  m_fontColorGradient:
+    topLeft: {r: 1, g: 1, b: 1, a: 1}
+    topRight: {r: 1, g: 1, b: 1, a: 1}
+    bottomLeft: {r: 1, g: 1, b: 1, a: 1}
+    bottomRight: {r: 1, g: 1, b: 1, a: 1}
+  m_fontColorGradientPreset: {fileID: 0}
+  m_spriteAsset: {fileID: 0}
+  m_tintAllSprites: 0
+  m_StyleSheet: {fileID: 0}
+  m_TextStyleHashCode: -1183493901
+  m_overrideHtmlColors: 0
+  m_faceColor:
+    serializedVersion: 2
+    rgba: 4294967295
+  m_fontSize: 24
+  m_fontSizeBase: 24
+  m_fontWeight: 400
+  m_enableAutoSizing: 0
+  m_fontSizeMin: 18
+  m_fontSizeMax: 72
+  m_fontStyle: 0
+  m_HorizontalAlignment: 8
+  m_VerticalAlignment: 256
+  m_textAlignment: 65535
+  m_characterSpacing: 0
+  m_wordSpacing: 0
+  m_lineSpacing: 0
+  m_lineSpacingMax: 0
+  m_paragraphSpacing: 0
+  m_charWidthMaxAdj: 0
+  m_enableWordWrapping: 1
+  m_wordWrappingRatios: 0.4
+  m_overflowMode: 0
+  m_linkedTextComponent: {fileID: 0}
+  parentLinkedComponent: {fileID: 0}
+  m_enableKerning: 1
+  m_enableExtraPadding: 0
+  checkPaddingRequired: 0
+  m_isRichText: 1
+  m_parseCtrlCharacters: 1
+  m_isOrthographic: 1
+  m_isCullingEnabled: 0
+  m_horizontalMapping: 0
+  m_verticalMapping: 0
+  m_uvLineOffset: 0
+  m_geometrySortingOrder: 0
+  m_IsTextObjectScaleStatic: 0
+  m_VertexBufferAutoSizeReduction: 1
+  m_useMaxVisibleDescender: 1
+  m_pageToDisplay: 1
+  m_margin: {x: 0, y: 0, z: 0, w: 0}
+  m_isUsingLegacyAnimationComponent: 0
+  m_isVolumetricText: 0
+  m_hasFontAssetChanged: 0
+  m_baseMaterial: {fileID: 0}
+  m_maskOffset: {x: 0, y: 0, z: 0, w: 0}
+--- !u!222 &1899073949
+CanvasRenderer:
+  m_ObjectHideFlags: 0
+  m_CorrespondingSourceObject: {fileID: 0}
+  m_PrefabInstance: {fileID: 0}
+  m_PrefabAsset: {fileID: 0}
+  m_GameObject: {fileID: 1899073946}
   m_CullTransparentMesh: 0
 --- !u!1 &1922022430
 GameObject:
@@ -30045,6 +31261,7 @@ MonoBehaviour:
   text: {fileID: 491682258}
   mapLegend: {fileID: 312072052}
   tableLegend: {fileID: 216146134}
+  labelCanvas: {fileID: 28716932}
   findBuildingBtn: {fileID: 244320316}
   toTable: TO TABLE
   toMap: TO MAP
@@ -31217,10 +32434,10 @@ RectTransform:
   m_Father: {fileID: 1641538590}
   m_RootOrder: 3
   m_LocalEulerAnglesHint: {x: 0, y: 0, z: 0}
-  m_AnchorMin: {x: 0, y: 1}
-  m_AnchorMax: {x: 0, y: 1}
-  m_AnchoredPosition: {x: 877.5, y: -479.63}
-  m_SizeDelta: {x: 1725, y: 38}
+  m_AnchorMin: {x: 0, y: 0}
+  m_AnchorMax: {x: 0, y: 0}
+  m_AnchoredPosition: {x: 0, y: 0}
+  m_SizeDelta: {x: 1725, y: 0}
   m_Pivot: {x: 0.5, y: 1}
 --- !u!114 &2016039611
 MonoBehaviour:
@@ -32731,6 +33948,140 @@ CanvasRenderer:
   m_PrefabAsset: {fileID: 0}
   m_GameObject: {fileID: 2085722378}
   m_CullTransparentMesh: 0
+--- !u!1 &2093300006
+GameObject:
+  m_ObjectHideFlags: 0
+  m_CorrespondingSourceObject: {fileID: 0}
+  m_PrefabInstance: {fileID: 0}
+  m_PrefabAsset: {fileID: 0}
+  serializedVersion: 6
+  m_Component:
+  - component: {fileID: 2093300007}
+  - component: {fileID: 2093300009}
+  - component: {fileID: 2093300008}
+  m_Layer: 5
+  m_Name: Gap (4)
+  m_TagString: Untagged
+  m_Icon: {fileID: 0}
+  m_NavMeshLayer: 0
+  m_StaticEditorFlags: 0
+  m_IsActive: 1
+--- !u!224 &2093300007
+RectTransform:
+  m_ObjectHideFlags: 0
+  m_CorrespondingSourceObject: {fileID: 0}
+  m_PrefabInstance: {fileID: 0}
+  m_PrefabAsset: {fileID: 0}
+  m_GameObject: {fileID: 2093300006}
+  m_LocalRotation: {x: 0, y: 0, z: 0, w: 1}
+  m_LocalPosition: {x: 0, y: 0, z: 0}
+  m_LocalScale: {x: 1, y: 1, z: 1}
+  m_Children: []
+  m_Father: {fileID: 1641538590}
+  m_RootOrder: 27
+  m_LocalEulerAnglesHint: {x: 0, y: 0, z: 0}
+  m_AnchorMin: {x: 0, y: 0}
+  m_AnchorMax: {x: 0, y: 0}
+  m_AnchoredPosition: {x: 0, y: 0}
+  m_SizeDelta: {x: 1725, y: 0}
+  m_Pivot: {x: 0.5, y: 0.5}
+--- !u!114 &2093300008
+MonoBehaviour:
+  m_ObjectHideFlags: 0
+  m_CorrespondingSourceObject: {fileID: 0}
+  m_PrefabInstance: {fileID: 0}
+  m_PrefabAsset: {fileID: 0}
+  m_GameObject: {fileID: 2093300006}
+  m_Enabled: 1
+  m_EditorHideFlags: 0
+  m_Script: {fileID: 11500000, guid: f4688fdb7df04437aeb418b961361dc5, type: 3}
+  m_Name: 
+  m_EditorClassIdentifier: 
+  m_Material: {fileID: 0}
+  m_Color: {r: 1, g: 1, b: 1, a: 1}
+  m_RaycastTarget: 1
+  m_Maskable: 1
+  m_OnCullStateChanged:
+    m_PersistentCalls:
+      m_Calls: []
+  m_text: ' '
+  m_isRightToLeft: 0
+  m_fontAsset: {fileID: 11400000, guid: 49750830b71ed3546bebefe4be946048, type: 2}
+  m_sharedMaterial: {fileID: 1742611629344109958, guid: 49750830b71ed3546bebefe4be946048,
+    type: 2}
+  m_fontSharedMaterials: []
+  m_fontMaterial: {fileID: 0}
+  m_fontMaterials: []
+  m_fontColor32:
+    serializedVersion: 2
+    rgba: 4278190080
+  m_fontColor: {r: 0, g: 0, b: 0, a: 1}
+  m_enableVertexGradient: 0
+  m_colorMode: 3
+  m_fontColorGradient:
+    topLeft: {r: 1, g: 1, b: 1, a: 1}
+    topRight: {r: 1, g: 1, b: 1, a: 1}
+    bottomLeft: {r: 1, g: 1, b: 1, a: 1}
+    bottomRight: {r: 1, g: 1, b: 1, a: 1}
+  m_fontColorGradientPreset: {fileID: 0}
+  m_spriteAsset: {fileID: 0}
+  m_tintAllSprites: 0
+  m_StyleSheet: {fileID: 0}
+  m_TextStyleHashCode: -1183493901
+  m_overrideHtmlColors: 0
+  m_faceColor:
+    serializedVersion: 2
+    rgba: 4294967295
+  m_fontSize: 24
+  m_fontSizeBase: 24
+  m_fontWeight: 400
+  m_enableAutoSizing: 0
+  m_fontSizeMin: 18
+  m_fontSizeMax: 72
+  m_fontStyle: 0
+  m_HorizontalAlignment: 8
+  m_VerticalAlignment: 256
+  m_textAlignment: 65535
+  m_characterSpacing: 0
+  m_wordSpacing: 0
+  m_lineSpacing: 0
+  m_lineSpacingMax: 0
+  m_paragraphSpacing: 0
+  m_charWidthMaxAdj: 0
+  m_enableWordWrapping: 1
+  m_wordWrappingRatios: 0.4
+  m_overflowMode: 0
+  m_linkedTextComponent: {fileID: 0}
+  parentLinkedComponent: {fileID: 0}
+  m_enableKerning: 1
+  m_enableExtraPadding: 0
+  checkPaddingRequired: 0
+  m_isRichText: 1
+  m_parseCtrlCharacters: 1
+  m_isOrthographic: 1
+  m_isCullingEnabled: 0
+  m_horizontalMapping: 0
+  m_verticalMapping: 0
+  m_uvLineOffset: 0
+  m_geometrySortingOrder: 0
+  m_IsTextObjectScaleStatic: 0
+  m_VertexBufferAutoSizeReduction: 1
+  m_useMaxVisibleDescender: 1
+  m_pageToDisplay: 1
+  m_margin: {x: 0, y: 0, z: 0, w: 0}
+  m_isUsingLegacyAnimationComponent: 0
+  m_isVolumetricText: 0
+  m_hasFontAssetChanged: 0
+  m_baseMaterial: {fileID: 0}
+  m_maskOffset: {x: 0, y: 0, z: 0, w: 0}
+--- !u!222 &2093300009
+CanvasRenderer:
+  m_ObjectHideFlags: 0
+  m_CorrespondingSourceObject: {fileID: 0}
+  m_PrefabInstance: {fileID: 0}
+  m_PrefabAsset: {fileID: 0}
+  m_GameObject: {fileID: 2093300006}
+  m_CullTransparentMesh: 0
 --- !u!1 &2096162682
 GameObject:
   m_ObjectHideFlags: 0
@@ -32809,6 +34160,80 @@ CanvasRenderer:
   m_PrefabAsset: {fileID: 0}
   m_GameObject: {fileID: 2096162682}
   m_CullTransparentMesh: 0
+--- !u!1 &2097123348
+GameObject:
+  m_ObjectHideFlags: 0
+  m_CorrespondingSourceObject: {fileID: 0}
+  m_PrefabInstance: {fileID: 0}
+  m_PrefabAsset: {fileID: 0}
+  serializedVersion: 6
+  m_Component:
+  - component: {fileID: 2097123349}
+  - component: {fileID: 2097123351}
+  - component: {fileID: 2097123350}
+  m_Layer: 5
+  m_Name: ToMap (2)
+  m_TagString: Untagged
+  m_Icon: {fileID: 0}
+  m_NavMeshLayer: 0
+  m_StaticEditorFlags: 0
+  m_IsActive: 1
+--- !u!224 &2097123349
+RectTransform:
+  m_ObjectHideFlags: 0
+  m_CorrespondingSourceObject: {fileID: 0}
+  m_PrefabInstance: {fileID: 0}
+  m_PrefabAsset: {fileID: 0}
+  m_GameObject: {fileID: 2097123348}
+  m_LocalRotation: {x: 0, y: 0, z: 0, w: 1}
+  m_LocalPosition: {x: 0, y: 0, z: 0}
+  m_LocalScale: {x: 1, y: 1, z: 1}
+  m_Children: []
+  m_Father: {fileID: 1641538590}
+  m_RootOrder: 31
+  m_LocalEulerAnglesHint: {x: 0, y: 0, z: 0}
+  m_AnchorMin: {x: 0, y: 0}
+  m_AnchorMax: {x: 0, y: 0}
+  m_AnchoredPosition: {x: 0, y: 0}
+  m_SizeDelta: {x: 357, y: 0}
+  m_Pivot: {x: 0.5, y: 0.5}
+--- !u!114 &2097123350
+MonoBehaviour:
+  m_ObjectHideFlags: 0
+  m_CorrespondingSourceObject: {fileID: 0}
+  m_PrefabInstance: {fileID: 0}
+  m_PrefabAsset: {fileID: 0}
+  m_GameObject: {fileID: 2097123348}
+  m_Enabled: 1
+  m_EditorHideFlags: 0
+  m_Script: {fileID: 11500000, guid: fe87c0e1cc204ed48ad3b37840f39efc, type: 3}
+  m_Name: 
+  m_EditorClassIdentifier: 
+  m_Material: {fileID: 0}
+  m_Color: {r: 1, g: 1, b: 1, a: 1}
+  m_RaycastTarget: 1
+  m_Maskable: 1
+  m_OnCullStateChanged:
+    m_PersistentCalls:
+      m_Calls: []
+  m_Sprite: {fileID: 21300000, guid: 764cc6d5558347d40ae77bea8b790eb8, type: 3}
+  m_Type: 0
+  m_PreserveAspect: 0
+  m_FillCenter: 1
+  m_FillMethod: 4
+  m_FillAmount: 1
+  m_FillClockwise: 1
+  m_FillOrigin: 0
+  m_UseSpriteMesh: 0
+  m_PixelsPerUnitMultiplier: 1
+--- !u!222 &2097123351
+CanvasRenderer:
+  m_ObjectHideFlags: 0
+  m_CorrespondingSourceObject: {fileID: 0}
+  m_PrefabInstance: {fileID: 0}
+  m_PrefabAsset: {fileID: 0}
+  m_GameObject: {fileID: 2097123348}
+  m_CullTransparentMesh: 0
 --- !u!1 &2099107656
 GameObject:
   m_ObjectHideFlags: 0
diff --git a/Client/Client/Assets/Scripts/MapRenderer.cs b/Client/Client/Assets/Scripts/MapRenderer.cs
index 0272041..2f7e498 100644
--- a/Client/Client/Assets/Scripts/MapRenderer.cs
+++ b/Client/Client/Assets/Scripts/MapRenderer.cs
@@ -15,6 +15,9 @@ public class MapRenderer : MonoBehaviour
     [SerializeField]
     public GameObject labelPrefab;
 
+    [SerializeField]
+    public GameObject smallLabelPrefab;
+
     [SerializeField]
     private SpriteRenderer underlayTemplate;
 
@@ -126,9 +129,21 @@ public class MapRenderer : MonoBehaviour
 
                     var label = Instantiate(labelPrefab, labelCanvas.transform);
                     var labelText = label.GetComponentInChildren<Text>();
+                    var labelPanel = label.gameObject.GetComponentInChildren<HorizontalLayoutGroup>();
                     labelText.text = name.ToUpper();
                     label.name = labelText.text;
 
+                    BuildingPanel.aliases.Add(name, img);
+
+                    for (int si = 5; si < split.Length; si++)
+                    {
+                        var smallLabel = Instantiate(smallLabelPrefab, labelPanel.transform);
+                        var smallLabelText = smallLabel.GetComponentInChildren<Text>();
+                        smallLabelText.text = split[si].ToUpper();
+                        smallLabel.name = smallLabelText.text;
+                        BuildingPanel.aliases.Add(split[si], img);
+                    }
+
                     PositionUpdater posup = label.GetComponent<PositionUpdater>();
                     posup.source = img.gameObject;
 
diff --git a/Client/Client/Assets/Scripts/UI/BuildingPanel.cs b/Client/Client/Assets/Scripts/UI/BuildingPanel.cs
index 062dcd9..ba28d4a 100644
--- a/Client/Client/Assets/Scripts/UI/BuildingPanel.cs
+++ b/Client/Client/Assets/Scripts/UI/BuildingPanel.cs
@@ -6,18 +6,76 @@ using UnityEngine.UI;
 
 public class BuildingPanel : PopUpPanel
 {
+    public static Dictionary<string, SpriteRenderer> aliases = new Dictionary<string, SpriteRenderer>();
+
+    public WebGLMapController map;
     public Button setBuildingButton;
+    public Button findBuildingButton;
     public InputField input;
     public Dropdown suggestion;
 
-    public void OnSetBuildingButton()
+    public void OnFindBuildingButton()
     {
+        if (aliases.ContainsKey(input.text.ToUpper()))
+            map.ZoomOn(aliases[input.text.ToUpper()]);
+        OnExit();
         OnExitButtonClicked();
     }
 
+    public void OnDropdownValueChanged()
+    {
+        input.text = suggestion.options[suggestion.value].text;
+        Debug.Log("set text: " + suggestion.options[suggestion.value].text);
+    }
+
+    public void OnEndInputEdit()
+    {
+        findBuildingButton.interactable = false;
+
+        var inputText = input.text.ToLower().Trim();
+        var trim = inputText.IndexOfAny("0123456789".ToCharArray());
+        if (trim >= 0)
+            inputText = inputText.Substring(0, trim);
+
+        foreach (var alias in aliases.Keys)
+        {
+            if (alias.ToLower().Trim() == inputText || alias.ToLower().Trim() == input.text.ToLower())
+            {
+                findBuildingButton.interactable = true;
+            }
+        }
+    }
+
     public void OnInputChanged()
     {
+        //Debug.Log(input.text);
+
+        suggestion.ClearOptions();
+
+        var inputText = input.text.ToLower().Trim();
+        var trim = inputText.IndexOfAny("0123456789".ToCharArray());
+        if (trim >= 0)
+            inputText = inputText.Substring(0, trim);
+
+        findBuildingButton.interactable = false;
+
+        foreach (var alias in aliases.Keys)
+        {
+            if (alias.ToLower().Trim().StartsWith(inputText))
+            {
+                suggestion.options.Add(new Dropdown.OptionData(alias));
+            }
+
+            if (alias.ToLower().Trim() == inputText || alias.ToLower().Trim() == input.text.ToLower())
+            {
+                findBuildingButton.interactable = true;
+            }
+        }
+
+        suggestion.enabled = false;
+        suggestion.enabled = true;
         suggestion.Show();
+
         EventSystem.current.SetSelectedGameObject(input.gameObject);
         if (isActiveAndEnabled) StartCoroutine(MoveCaretToEnd());
     }
diff --git a/Client/Client/Assets/Scripts/UI/MapSwapper.cs b/Client/Client/Assets/Scripts/UI/MapSwapper.cs
index 2203e0f..1df2fec 100644
--- a/Client/Client/Assets/Scripts/UI/MapSwapper.cs
+++ b/Client/Client/Assets/Scripts/UI/MapSwapper.cs
@@ -13,6 +13,8 @@ public class MapSwapper : MonoBehaviour
     public GameObject mapLegend;
     public GameObject tableLegend;
 
+    public Canvas labelCanvas;
+
     public Button findBuildingBtn;
 
     public string toTable;
@@ -40,9 +42,9 @@ public class MapSwapper : MonoBehaviour
             text.text = toMap;
 
             findBuildingBtn.interactable = false;
+            labelCanvas.gameObject.SetActive(false);
             mapLegend.SetActive(false);
             tableLegend.SetActive(true);
-
         }
         else
         {
@@ -60,6 +62,7 @@ public class MapSwapper : MonoBehaviour
             text.text = toTable;
 
             findBuildingBtn.interactable = true;
+            labelCanvas.gameObject.SetActive(true);
             mapLegend.SetActive(true);
             tableLegend.SetActive(false);
         }
diff --git a/Client/Client/Assets/Scripts/UI/WeatherPanel.cs b/Client/Client/Assets/Scripts/UI/WeatherPanel.cs
index 58d0ab2..1c14d9c 100644
--- a/Client/Client/Assets/Scripts/UI/WeatherPanel.cs
+++ b/Client/Client/Assets/Scripts/UI/WeatherPanel.cs
@@ -101,17 +101,17 @@ public class WeatherPanel : PopUpPanel
             return;
         }    
 
-        if (rainValue < 0)
+        if (rainValue < 0 || rainValue > 100)
         {
             errorText.gameObject.SetActive(true); 
-            errorText.text = "RAIN PROBABILITY MUST BE POSITIVE";
+            errorText.text = "RAIN PROBABILITY MUST BE FROM 0 TO 100";
             return;
         }
 
         if (windValue < 0)
         {
             errorText.gameObject.SetActive(true); 
-            errorText.text = "WIND SPEED MUST BE POSITIVE";
+            errorText.text = "WIND SPEED MUST BE ZERO OR MORE";
             return;
         }
 
diff --git a/Client/Client/Assets/Scripts/Weather/WeatherManager.cs b/Client/Client/Assets/Scripts/Weather/WeatherManager.cs
index b8ff4bb..df0fba7 100644
--- a/Client/Client/Assets/Scripts/Weather/WeatherManager.cs
+++ b/Client/Client/Assets/Scripts/Weather/WeatherManager.cs
@@ -83,7 +83,6 @@ public class WeatherManager : MonoBehaviour, WeatherObserver
 
     public void Clear()
     {
-        provider = new WeatherProvider(data, networkingManager);
         provider.Load();
     }
 }
diff --git a/Client/Client/Assets/Scripts/Weather/WeatherProvider.cs b/Client/Client/Assets/Scripts/Weather/WeatherProvider.cs
index ef2db58..8b0bc1c 100644
--- a/Client/Client/Assets/Scripts/Weather/WeatherProvider.cs
+++ b/Client/Client/Assets/Scripts/Weather/WeatherProvider.cs
@@ -13,6 +13,8 @@ public class WeatherProvider
     private JsonParser parser;
     private WeatherData data;
 
+    private static DateTime lastDownload = DateTime.Now.AddHours(-2);
+
     public WeatherProvider(WeatherData data, NetworkingManager networkingManager)
     {
         this.data = data;
@@ -22,7 +24,33 @@ public class WeatherProvider
 
     public void Load()
     {
-        networkingManager.StartWeatherGet(this, uri);
+        DateTime next = lastDownload.AddHours(1);
+
+        Debug.Log($"Last: {lastDownload.ToShortDateString()} {lastDownload.ToShortTimeString()}");
+        Debug.Log($"Now: {DateTime.Now.ToShortDateString()} {DateTime.Now.ToShortTimeString()}");
+        Debug.Log($"Next: {next.ToShortDateString()} {next.ToShortTimeString()}");
+
+        if (next < DateTime.Now)
+        {
+            Debug.Log("Passing to load");
+            lastDownload = DateTime.Now;
+            networkingManager.StartWeatherGet(this, uri);
+        }
+        else
+        {
+            int day = DateTime.Now.Day;
+            int month = DateTime.Now.Month;
+            int year = DateTime.Now.Year;
+            int hour = DateTime.Now.Hour;
+
+            var date = new Date();
+            date.day = day;
+            date.month = month;
+            date.year = year;
+            date.hour = hour;
+
+            Load(date);
+        }
     }
 
     public void LoadFromResponse(string response)
diff --git a/Client/Client/Assets/Scripts/WebGLMapController.cs b/Client/Client/Assets/Scripts/WebGLMapController.cs
index c639012..9cbd9ee 100644
--- a/Client/Client/Assets/Scripts/WebGLMapController.cs
+++ b/Client/Client/Assets/Scripts/WebGLMapController.cs
@@ -23,7 +23,7 @@ public class WebGLMapController : MonoBehaviour
 	private Vector3 screenPoint;
 	private Vector3 offset;
 
-	public bool block;
+    public bool block;
 	public bool blockExternal;
 
 	void Start()
@@ -173,4 +173,23 @@ public class WebGLMapController : MonoBehaviour
 		return new Bounds(bounds.center, size);
 	}
 
+	public void ZoomOn(SpriteRenderer sprite)
+	{
+		if (sprite == null)
+        {
+			Debug.LogError("Zooming on null spriteRenderer. Skipping operation.");
+			return;
+        }
+
+		Vector3 localScale = new Vector3(maxScale, maxScale, 1);
+		map.transform.localScale = localScale;
+
+		var from = Camera.main.ViewportToWorldPoint(new Vector3(0.5f, 0.5f, 10f));
+		var to = sprite.transform.position;
+
+		map.transform.position = map.transform.position - (to - from);
+	
+		ClampPan();
+	}
+
 }
